
Redmine - Patch #3917

Fix for mercurial diff not working

2009-09-24 14:51 - Dave Winzler

Status: Closed Start date: 2009-09-24

Priority: Normal Due date:  

Assignee: Toshi MARUYAMA % Done: 0%

Category: SCM Estimated time: 0.00 hour

Target version:    

Description

Problem:

When reviewing file-level changes in Mercurial repositories, URLs of the form below fail with the error "The entry or revision was not

found in the repository":

http://redmine.example.com/repositories/diff/myproj/myfile.php?rev=39

 This link can be found when reviewing a revision, to the right of each revised file click on the word "diff" inside of parentheses.

The issue is caused because a badly formed shell command is being generated. What should be generated is

/usr/bin/hg -R 'file:///path_to_myproj/' diff -r 38 -r 39 --nodates -I '/path_to_myproj/myfile.php'

What is actually generated is:

/usr/bin/hg -R 'file:///path_to_myproj/' diff -r 38 -r 39 --nodates -I 'file:///path_to_myproj/myfile.php'

Fix:

In /lib/redmine/scm/adapters/mercurial_adapter.rb, replace this line:

cmd << " -I #{target(path)}" unless path.empty?

 with:

unless path.empty?

            filepath = target(path).sub(/file:\/\//, '')

           cmd << " -I #{filepath}"

          end

Related issues:

Is duplicate of Redmine - Defect #6911: Viewing files or diff with mercurial ... Closed 2010-11-16

History

#1 - 2010-03-28 13:47 - Yuya Nishihara

Dave Winzler wrote:

What is actually generated is:

/usr/bin/hg -R 'file:///path_to_myproj/' diff -r 38 -r 39 --nodates -I 'file:///path_to_myproj/myfile.php'

 Did you configure the "Root directory" of your repo as "file:///path_to_myproj/" ?

It should be a directory path "/path_to_myproj/", not a URL.

If not, please provide Redmine version.

#2 - 2010-03-28 14:11 - Dave Winzler

Yuya, thanks for identifying the problem. Yes, I was using a file: URI rather than an absolute path. All works as it should now, thank you!

#3 - 2011-01-02 13:59 - Toshi MARUYAMA

- Category set to SCM

#4 - 2011-01-02 14:01 - Toshi MARUYAMA

- Assignee set to Toshi MARUYAMA
#5 - 2011-01-06 11:33 - Toshi MARUYAMA

- Status changed from New to Closed

This issue is duplicate with #6911. I close this issue.

"file://" is common issue of git and mercurial.
